#include "widget.h"
#include "ui_widget.h"

#include "Structs.h"
#include <unistd.h>
#include <stdio.h>
#include<signal.h>
#include <sys/types.h>
#include <fcntl.h>
#include<string.h>
#include<stdlib.h>

#include<QSet>
#include<QMessageBox>
#include<QTableWidget>
#include<QTableWidgetItem>
#include<QSemaphore>
#include<QInputDialog>
#include<QDir>

#define MAX_BUFFER 1024
#define READ_OFFSET 0x400
#define N_OF_WORDS 40
#define N_OF_COLS 4
#define N_OF_ROWS 10
#define NofWordBank 100


Ui::Widget *my_ui;
Widget *my_widget;

 typedef void (*int_handler_t)(void *);
 void * USER_int_handler_arg;
 int_handler_t USER_int_handler = NULL;

int p9030_fd;
int fd;
QString MY_NAME = "ME";
QString OPPOSITE_NAME = "YOU";

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//define words
////////////////// ///////////////////////////////////////////////////////////////////////////////////////////////
char* words[NofWordBank]={
    "유리", "티파니", "서현", "윤아", "써니", "효연", "태연", "제시카","수영","제아",
   "나르샤", "미료", "가인", "김재경", "고우리", "김지숙", "노을", "오승아","정윤혜","조현영",
   "박규리", "니콜", "한승연", "구하라", "김지영", "지연", "은정", "효민","보람","큐리",
   "소연", "선예", "선미", "소희", "예은", "유빈", "박정아", "서인영","하주연","김은정",
   "박봄", "이채린", "공민지", "산다라박", "남지현", "허가윤", "전지윤", "김현아","권소현","주연",
   "베카","가희","정아","유이","나나","레이나","이해리","강민경","빅토리아","크리스탈",
   "엠버","설리","가연","수연","유미","세미","다은","장희영","노시현","미스티",
   "김연지","이보람","수미","신연아","이지영","이영현","박민혜","수지","채린","수아",
   "바거","정방개","알헤나","빵꾸똥꾸","고유진","박화요비","심민조석","신혜성","애봉이","센세이션",
   "김정남","호빵맨","세균맨","식빵맨","배트맨","스파이더맨","슈퍼맨","요맨","라맨","와썹맨"
        };

char* itemwords[10]={
    "재범", "준수", "닉쿤", "택연", "우영", "준호", "찬성", "조권", "임슬옹", "이창민"
};
 QString itemnum;
QVector<QString> wordsVector;
QSet<QString>wordsSet;
QString wordsStr;
QSemaphore sem(1);
QSet<QString>itemSet;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// declair functions
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////


void pci9030_int_handler(int signo);
int PCI9030_Start( int fd );
int PCI9030_Enable_Lint();
int PCI9030_Disable_Lint();
int PCI9030_CS_Write(unsigned char *data, unsigned int offset, int length);
int PCI9030_CS_Read(unsigned char *data, unsigned int offset, int length);
int PCI9030_GPIO_Set();
int PCI9030_GPIO_Clear();

int p1score;
int p2score;

void GPIO_Set();
void GPIO_Clear();
void E_Lint_Menu();
void D_Lint_Menu();
void DPRAM_Write(QString getStr);
void DPRAM_Read();
void init();
void countN(int n);

void parse_getmsg(unsigned char*data);
void print_msg(QString msg,int flag);
void initGame();
void receiptStartGame();
void startGame();
void sendWord(QString aWord);

void wordRemove(QString word);
void printP2score(int score);
void endGame(int n);

///////////////////////////////////////////////////////////////////////////////////////////////////////////
// ui part
///////////////////////////////////////////////////////////////////////////////////////////////////////////
Widget::Widget(QWidget *parent)
    : QWidget(parent), ui(new Ui::Widget)
{
    init();
    ui->setupUi(this);
    USER_int_handler = NULL;
    ui->inputTextBox->setFocus();
    my_ui = ui;
    my_widget = this;

    ui->p1name->setText(MY_NAME);
    ui->p2name->setText(OPPOSITE_NAME);
    ui->readyImg->setVisible(false);
    //ui->receiptBtn->setVisible(false);

    ui->chatMode->setDisabled(true);
    ui->outputTextBox->append("System > Program complete Loaded .. ");

}

Widget::~Widget()
{
    fd = close();
    delete ui;
}

void Widget::on_sendBtn_clicked()
{
    QString sstr;

    if(ui->inputTextBox->text() == ""){
    }
    else if(ui->inputTextBox->text() == "/a"){
        my_ui->chatMode->setCurrentIndex(0);
        ui->inputTextBox->clear();
        ui->inputTextBox->setFocus();
        return;
    } else  if(ui->inputTextBox->text() == "/g"){
        my_ui->chatMode->setCurrentIndex(1);
        ui->inputTextBox->clear();
        ui->inputTextBox->setFocus();
        return;
    } else  if(my_ui->chatMode->currentIndex() == 0){
        //채팅 모드일 경우
        sstr = "0";
        sstr += ui->inputTextBox->text();
         DPRAM_Write(sstr);
    } else{
        //게임 모드일 경우
         QString word = ui->inputTextBox->text();
         if(wordsSet.find(word) != wordsSet.end()) {
             sendWord(word);
            //int sendingScore = sendWord(word);
            //sendScore(sendingScore);

        }else if(word == itemnum && itemnum != ""){
            sstr="1101";
            sstr+=QString::number(rand()%2);

            DPRAM_Write(sstr);
            itemnum = "";
            my_ui->bonusTable->clear();
        }

    }

    ui->inputTextBox->clear();
    ui->inputTextBox->setFocus();

}
void Widget::on_inputTextBox_returnPressed()
{
    on_sendBtn_clicked();
}

void Widget::clockTimer()
{
//    QString itemtitle="ITEM WORD";
//    QTableWidgetItem* temp= new QTableWidgetItem(itemtitle,QTableWidgetItem::Type);
//    ui->bonusTable->setItem(0,0,temp);
    for(int i = 0 ; i < 4 ; i++){
        QTableWidgetItem* clear = new QTableWidgetItem((QString)"",QTableWidgetItem::Type);
        ui->bonusTable->setItem(0,i,clear);
    }
     int idx = rand()%10;
    int pos = rand()%4;
    itemnum=itemnum.fromLocal8Bit((const char*)itemwords[idx],strlen((const char*)itemwords[idx]));
      QTableWidgetItem* temp1= new QTableWidgetItem(itemnum,QTableWidgetItem::Type);
     ui->bonusTable->setItem(0,pos,temp1);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//pci_io.h part
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int PCI9030_Enable_Lint()
{
        IO_Block IO_Blck;

        IO_Blck.tag = 'e';
        write( p9030_fd, &IO_Blck, sizeof(IO_Block) );
        return 1;
}

int PCI9030_Disable_Lint()
{
        IO_Block IO_Blck;

        IO_Blck.tag = 'd';
        write( p9030_fd, &IO_Blck, sizeof(IO_Block) );
        return 1;
}
void pci9030_int_handler(int signo)
{
        //printf("Test handler is CALLED....WOW!!\n");
        if(USER_int_handler!=NULL)
        {
                USER_int_handler(USER_int_handler_arg);
        }
        printf("get interrupt\n");
        DPRAM_Read();
}
int PCI9030_Start( int fd )
{
        int oflags;

        p9030_fd = fd;

        // enable asynronous notification

       signal(SIGIO,&pci9030_int_handler);
        fcntl(p9030_fd, F_SETOWN, getpid());
        oflags = fcntl(p9030_fd, F_GETFL);
        fcntl(p9030_fd, F_SETFL, oflags | FASYNC);

        return 1;
}
int PCI9030_CS_Write(unsigned char *data, unsigned int offset, int length)
{
        //int i;
        IO_Block IO_Blck;

        IO_Blck.tag = 'o';
        IO_Blck.data = data;
        IO_Blck.offset = offset;
        IO_Blck.length = length;

        write( p9030_fd, &IO_Blck, sizeof( IO_Block ) );
        printf("transe data\n");
        return 1;
}
int PCI9030_CS_Read(unsigned char *data, unsigned int offset, int length)
{
        //int i;
        IO_Block IO_Blck;

        IO_Blck.tag = 'i';
        IO_Blck.data = data;
        IO_Blck.offset = offset;
        IO_Blck.length = length;
        write( p9030_fd, &IO_Blck, sizeof( IO_Block ) );
        printf("read data\n");
        return 1;
}
int PCI9030_GPIO_Set()
{
        IO_Block IO_Blck;

        IO_Blck.tag = 's';
        write( p9030_fd, &IO_Blck, sizeof(IO_Block) );
        return 1;
}
int PCI9030_GPIO_Clear()
{
        IO_Block IO_Blck;

        IO_Blck.tag = 'c';
        write( p9030_fd, &IO_Blck, sizeof(IO_Block) );
        return 1;
}

/////////////////////////////////////////////////////////////////////////////////////////
// function part
/////////////////////////////////////////////////////////////////////////////////////////

void E_Lint_Menu()
{
        PCI9030_Enable_Lint();
}

void D_Lint_Menu()
{
        PCI9030_Disable_Lint();
}

void Lint_Software_Int_Menu()
{
        //PCI9030_Lint_Software_Int();
}

void GPIO_Set()
{
        PCI9030_GPIO_Set();
}

void GPIO_Clear()
{
        PCI9030_GPIO_Clear();
}
void DPRAM_Write(QString getStr)
{
       sem.acquire(1);

        my_ui->debugMsg->append("SEND : "+getStr);
         char data[MAX_BUFFER];
         const char* data2 = getStr.toLocal8Bit();

        unsigned int offset = 0x00;
        strcpy(data,data2);

        PCI9030_CS_Write( (unsigned char*)data, offset, strlen((const char*)data) );

        if(getStr[0] == '0'){
            getStr.remove(0,1);
            print_msg(getStr,0);
        }
         GPIO_Set();
         GPIO_Clear();

      sem.release(1);
}
void DPRAM_Read()
{
        unsigned char data[MAX_BUFFER];
        unsigned int offset;
        int length;
        memset(data,0,sizeof(data));

        offset = READ_OFFSET;
        length = sizeof(char)*MAX_BUFFER;
        PCI9030_CS_Read( data, offset, length);

        parse_getmsg(data);
}

void init(){
    D_Lint_Menu();
     fd = open( "/dev/mydrv", O_RDWR );
    PCI9030_Start( fd );
    E_Lint_Menu();
}
//////////////////////////////////////////////////////////////////////////////////////
// MY Function Part
//////////////////////////////////////////////////////////////////////////////////////
void print_msg(QString msg,int flag){
    if(flag == 0){
        msg.push_front(" > ");
        msg.push_front(MY_NAME);
    }
    if(flag == 1){
        msg.push_front(" > ");
         msg.push_front(OPPOSITE_NAME);
    }
     my_ui->outputTextBox->append(msg);
}

void parse_getmsg(unsigned char* data){
  // QString getData = (const char*)data;
    QString rstr;
     rstr = rstr.fromLocal8Bit((const char*)data,strlen((const char*)data));
    my_ui->debugMsg->append("first input : "+rstr);

   if(rstr[0] == '0'){
       if(rstr !=""){
        rstr.remove(0,1);
        my_ui->debugMsg->append(rstr);
        print_msg(rstr,1);
    }
   }
   else if(rstr[0] == '1'){
       rstr.remove(0,1);
       //000 게임 시작 요청 -단어 셋도 같이 따라옴
       if(rstr[0] == '0' && rstr[1] == '0' && rstr[2] == '0'){
           rstr.remove(0,3);

            my_ui->debugMsg->append(rstr);
           QStringList strList = rstr.split(QRegExp("\\W+"),QString::SkipEmptyParts);
           for(int i = 0 ; i < strList.size(); i++){
               wordsVector.push_back(strList.at(i));
               wordsSet.insert(strList.at(i));
           }
            receiptStartGame();
       } else if(rstr[0] == '0' && rstr[1] == '0' && rstr[2] == '1'){
              //001 게임 요청 수락
            rstr.remove(0,3);
            if(rstr[0] == '0'){
               startGame();
            }
       }
       //101 뭐지?
         else if(rstr[0]=='1' && rstr[1]=='0'&&rstr[2]=='1'){
            rstr.remove(0,3);
            my_ui->bonusTable->clear();
            itemnum = "";
            if(rstr[0]=='0')
            {
                  my_ui->inputTextBox->setDisabled(true);
                QTimer::singleShot(3000,my_widget,SLOT(inputEnable()));
            }
            else if(rstr[0]=='1')
            {
                my_ui->wordTable->setVisible(false);
                 QTimer::singleShot(3000,my_widget,SLOT(wordEnable()));
            }

       }
         ////////////////////////////////////////////////////////////////////////////
///////////////////donxu revised -------------------------------------------
       else if(rstr[0] == '1' && rstr[1] == '0' &&  rstr[2] == '0'){
           //100 졌음
           rstr.remove(0, 3);
           int scoreToPlus = rstr.length();
           printP2score(scoreToPlus);
           wordRemove(rstr);
           endGame(1);
       } else if(rstr[0] == '1' && rstr[1] == '1' && rstr[2] == '0'){
           //110 상대편이 맞춘 단어
            rstr.remove(0,3);
            int scoreToPlus = rstr.length();
            printP2score(scoreToPlus);
            wordRemove(rstr);
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
        }  else if(rstr[0]=='1' && rstr[1]=='1' && rstr[2]=='1'){
       //캐릭터갱신
            rstr.remove(0,3);
            if(rstr[0] == '0'){
                rstr.remove(0, 1);
                my_ui->p2Pic->setPixmap(QPixmap(rstr));
                my_ui->p2Pic->setGeometry(my_ui->p2Pic->geometry().x(),my_ui->p2Pic->geometry().y(),my_ui->p2Pic->geometry().width(),my_ui->p2Pic->geometry().height());
                my_ui->p2Pic->setScaledContents(true);
            }
            else if(rstr[0] == '1')
            {
                //아이디 갱신할 부분
                rstr.remove(0,1);
                my_ui->p2name->setText(rstr);
                OPPOSITE_NAME = rstr;
            }
            else{
                printf("error\n");
            }
        }
        else{
        printf("Data header Error!!\n");
        printf("Data : %s",rstr);
      }
   }
}

void initGame(){

    p1score = 0;
    p2score = 0;
     my_ui->p1score->display(QString::number(p1score));
     my_ui->p2score->display(QString::number(p2score));

    QVector<QTableWidgetItem*> item;
    for(int i = 0 ; i < N_OF_WORDS ; i++){
        item.push_back(new QTableWidgetItem(wordsVector[i],QTableWidgetItem::Type));
    }

    for(int i = 0 ; i<N_OF_WORDS ; i++){
        my_ui->wordTable->setItem((int)i/N_OF_COLS,(int)i%N_OF_COLS,item[i]);
    }
}

QString makeWordSet(){
    QString wordstr;
    QString sourceStr;
    QSet<int> wordset;
    wordsVector.clear();
    srand((unsigned)time(NULL));
    while(wordset.size() != N_OF_WORDS){
         int idx = rand()%NofWordBank;
        sourceStr = sourceStr.fromLocal8Bit((const char*)words[idx],strlen((const char*)words[idx]));
        if(wordset.find(idx) == wordset.end()){
            my_ui->debugMsg->append(sourceStr);
            wordset.insert(idx);
            wordsVector.push_back(sourceStr);
            wordsSet.insert(sourceStr);
            wordstr += sourceStr;
            wordstr += " ";
        }
    }
    return wordstr;
}

void receiptStartGame(){
    int flag = my_widget->getReceiptResult();
    my_ui->debugMsg->append(QString::number(flag));

     QString smsg;
     if(flag == 16384){
         smsg = "10010";
         DPRAM_Write(smsg);
         startGame();

     }
     else{
        smsg = "10011";
        DPRAM_Write(smsg);
     }
}

void startGame(){
   // my_ui->wordTable->setVisible(false);
    my_ui->inputTextBox->setEnabled(false);
    my_ui->readyImg->setVisible(true);
    my_ui->chatMode->setDisabled(false);
    my_ui->startGameBtn->setDisabled(true);

    initGame();
    char* waitMsgHead = "System > +++게임 시작 까지 ";
    char* waitMsgTail = " 초 남았습니다.+++";
    char* startMsg = "게임 시작합니다.!!";
    QString waitMsg;

    my_ui->chatMode->setCurrentIndex(1);
   for(int i = 5 ; i >= 0 ; i--){
       waitMsg = "";
        waitMsg += waitMsg.fromLocal8Bit((const char*)waitMsgHead,strlen((const char*)waitMsgHead));
        waitMsg += QString::number(i);
        waitMsg += waitMsg.fromLocal8Bit((const char*)waitMsgTail,strlen((const char*)waitMsgTail));
        my_ui->outputTextBox->append(waitMsg);
        my_ui->outputTextBox->repaint();
        sleep(1);
   }
   //아이템셋 초기화
   QString rstr;
   for(int i=0;i<10;i++)
   {
     rstr = rstr.fromLocal8Bit((const char*)itemwords,strlen((const char*)itemwords));
     itemSet.insert(rstr);
   }

   waitMsg = waitMsg.fromLocal8Bit((const char*)startMsg,strlen((const char*)startMsg));
   my_ui->inputTextBox->setEnabled(true);
   my_ui->inputTextBox->setFocus();
    //my_ui->wordTable->setVisible(true);
    my_ui->readyImg->setVisible(false);
    my_widget->timer=new QTimer(my_widget);
    my_widget->connect(my_widget->timer,SIGNAL(timeout()),SLOT(clockTimer()));
    my_widget->timer->start(10000);


}


////////////////////////////////////////////////////////////////
//----------------------donxu revised -------------------------
void sendWord(QString aWord){
    //wordsSet에서 해당 단어를 지우고 테이블에서도 삭제
    wordRemove(aWord);

    //점수를 점수판에 더한다.
    int scoreToPlus = aWord.length();
    p1score += scoreToPlus;
    my_ui->p1score->display(p1score);

    if(wordsSet.empty()) {      //wordsSet 이 텅 비었다면 내가 winner
        QString sstr = "1100" + aWord;
        DPRAM_Write(sstr);
        endGame(0);
    } else {
        //단어 전송
        QString sstr = "1110";
        sstr += aWord;
        DPRAM_Write(sstr);
    }
}
/////////////--------------------------------------------
////////////////////////////////////////////////////////////////

int Widget::getReceiptResult(){
    int flag = QMessageBox::question(this,tr("Receipt Start Game"),(QString)"Receipt Start Game?",QMessageBox::Yes,QMessageBox::No);
    return flag;
}

void Widget::on_startGameBtn_clicked()
{
   int flag = QMessageBox::question(this,tr("Request Start Game"),(QString)"Require Start Game?",QMessageBox::Yes,QMessageBox::No);
   printf("messagebox data : %d\n",flag);
   if(flag == 16384){
        QString smsg;
        smsg = "1000";
        smsg += makeWordSet();
        ui->debugMsg->append(smsg);
        DPRAM_Write(smsg);
    }
}


void wordRemove(QString word) {
    wordsSet.remove(word);
    for(int i = 0 ; i < wordsVector.size() ; i++){
        if(wordsVector[i] == word){
            QString emptyword = "";
            QTableWidgetItem* item = new QTableWidgetItem(emptyword,QTableWidgetItem::Type);
            my_ui->wordTable->setItem((int)i/N_OF_COLS,(int)i%N_OF_COLS,item);
            break;
        }
    }
}
///////////////////////////////////////////////////////////////////
////////////////////////donxu revised ------------------------------
void printP2score(int score) {
    p2score += score;
    my_ui->p2score->display(QString::number(p2score));
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
void endGame(int n){
    int p1Score = my_ui->p1score->value();
    int p2Score = my_ui->p2score->value();

    if(p1Score>p2Score){
        QMessageBox::information(my_widget, "Game Over", "You are Winner.", QMessageBox::Ok);
    }
    else if(p1Score<p2Score){
        QMessageBox::information(my_widget, "Game Over", "You are Looser", QMessageBox::Ok);
    }
    else{
        QMessageBox::information(my_widget, "Game Over", "Draw", QMessageBox::Ok);
    }

    my_ui->chatMode->setCurrentIndex(0);
    my_ui->chatMode->setDisabled(true);
    my_ui->startGameBtn->setDisabled(false);

    my_ui->chatMode->setCurrentIndex(0);
    wordsVector.clear();
    wordsSet.clear();
    my_widget->timer->stop();
}

void Widget::on_picCom_currentIndexChanged(QString )
{
    QString filename;
    filename=my_ui->picCom->currentText();
    filename+=".jpg";
    my_ui->p1Pic->setPixmap((QPixmap(filename)));
    my_ui->p1Pic->setGeometry(my_ui->p1Pic->geometry().x(),my_ui->p1Pic->geometry().y(),my_ui->p1Pic->geometry().width(),my_ui->p1Pic->geometry().height());
    my_ui->p1Pic->setScaledContents(true);
    QString smg="11110";
    smg+=filename;
    DPRAM_Write(smg);
}
void Widget::inputEnable()
{
    my_ui->debugMsg->append("inputEnable()");
    my_ui->inputTextBox->setEnabled(true);
    my_ui->inputTextBox->setFocus();
}
void Widget::wordEnable()
{
    my_ui->debugMsg->append("wordEnable()");
    my_ui->wordTable->setVisible(true);
}

void Widget::on_pushButton_clicked()
{
    //팝업창을 띄워 아이디를 바꾼 다음 '11111'로 앞에 붙여서 보냄
    bool ok;
    QString id = QInputDialog::getText(this, tr("Enter your name"), tr("User name:"), QLineEdit::Normal, "", &ok);
    if(ok)
        ui->p1name->setText(id);
   MY_NAME=id;
    id.push_front("11111");
    DPRAM_Write(id);
}
